Commit 4321ad4e authored by Namhyung Kim's avatar Namhyung Kim Committed by Arnaldo Carvalho de Melo

perf test: Use a test program in 'perf record' tests

If the system has cc it could build a test program with two threads
and then use it for more detailed testing.  Also it accepts an option
to run a thread forever to ensure multi-thread runs.

If cc is not found, it falls back to use the default value 'true'.
Reviewed-by: default avatarAdrian Hunter <adrian.hunter@intel.com>
Signed-off-by: default avatarNamhyung Kim <namhyung@kernel.org>
Acked-by: default avatarIan Rogers <irogers@google.com>
Cc: Ingo Molnar <mingo@kernel.org>
Cc: Jiri Olsa <jolsa@kernel.org>
Cc: Peter Zijlstra <peterz@infradead.org>
Link: https://lore.kernel.org/r/20221020172643.3458767-4-namhyung@kernel.orgSigned-off-by: default avatarArnaldo Carvalho de Melo <acme@redhat.com>
parent 9e455f4f
...@@ -6,10 +6,17 @@ set -e ...@@ -6,10 +6,17 @@ set -e
err=0 err=0
perfdata=$(mktemp /tmp/__perf_test.perf.data.XXXXX) perfdata=$(mktemp /tmp/__perf_test.perf.data.XXXXX)
testprog=$(mktemp /tmp/__perf_test.prog.XXXXXX)
testsym="test_loop"
cleanup() { cleanup() {
rm -f "${perfdata}" rm -f "${perfdata}"
rm -f "${perfdata}".old rm -f "${perfdata}".old
if [ "${testprog}" != "true" ]; then
rm -f "${testprog}"
fi
trap - EXIT TERM INT trap - EXIT TERM INT
} }
...@@ -19,9 +26,56 @@ trap_cleanup() { ...@@ -19,9 +26,56 @@ trap_cleanup() {
} }
trap trap_cleanup EXIT TERM INT trap trap_cleanup EXIT TERM INT
build_test_program() {
if ! [ -x "$(command -v cc)" ]; then
# No CC found. Fall back to 'true'
testprog=true
testsym=true
return
fi
echo "Build a test program"
cat <<EOF | cc -o ${testprog} -xc - -pthread
#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
void test_loop(void) {
volatile int count = 1000000;
while (count--)
continue;
}
void *thfunc(void *arg) {
int forever = *(int *)arg;
do {
test_loop();
} while (forever);
return NULL;
}
int main(int argc, char *argv[]) {
pthread_t th;
int forever = 0;
if (argc > 1)
forever = atoi(argv[1]);
pthread_create(&th, NULL, thfunc, &forever);
test_loop();
pthread_join(th, NULL);
return 0;
}
EOF
}
test_per_thread() { test_per_thread() {
echo "Basic --per-thread mode test" echo "Basic --per-thread mode test"
if ! perf record -o /dev/null --quiet true 2> /dev/null if ! perf record -o /dev/null --quiet ${testprog} 2> /dev/null
then then
echo "Per-thread record [Skipped event not supported]" echo "Per-thread record [Skipped event not supported]"
if [ $err -ne 1 ] if [ $err -ne 1 ]
...@@ -30,13 +84,13 @@ test_per_thread() { ...@@ -30,13 +84,13 @@ test_per_thread() {
fi fi
return return
fi fi
if ! perf record --per-thread -o "${perfdata}" true 2> /dev/null if ! perf record --per-thread -o "${perfdata}" ${testprog} 2> /dev/null
then then
echo "Per-thread record [Failed record]" echo "Per-thread record [Failed record]"
err=1 err=1
return return
fi fi
if ! perf report -i "${perfdata}" -q | grep -q true if ! perf report -i "${perfdata}" -q | grep -q "${testsym}"
then then
echo "Per-thread record [Failed missing output]" echo "Per-thread record [Failed missing output]"
err=1 err=1
...@@ -62,7 +116,7 @@ test_register_capture() { ...@@ -62,7 +116,7 @@ test_register_capture() {
return return
fi fi
if ! perf record -o - --intr-regs=di,r8,dx,cx -e br_inst_retired.near_call:p \ if ! perf record -o - --intr-regs=di,r8,dx,cx -e br_inst_retired.near_call:p \
-c 1000 --per-thread true 2> /dev/null \ -c 1000 --per-thread ${testprog} 2> /dev/null \
| perf script -F ip,sym,iregs -i - 2> /dev/null \ | perf script -F ip,sym,iregs -i - 2> /dev/null \
| grep -q "DI:" | grep -q "DI:"
then then
...@@ -73,6 +127,8 @@ test_register_capture() { ...@@ -73,6 +127,8 @@ test_register_capture() {
echo "Register capture test [Success]" echo "Register capture test [Success]"
} }
build_test_program
test_per_thread test_per_thread
test_register_capture test_register_capture
......
Markdown is supported
0%
or
You are about to add 0 people to the discussion. Proceed with caution.
Finish editing this message first!
Please register or to comment